#include <pic.h>
#include "LCD_Defs.h"
#include "Main.h"
 
 
union
{ 	
	unsigned int Full_Timer ;
	unsigned char Timer_Byte[2] ;
}CSM;

unsigned char CSM_Flag = 0;
unsigned char W_Index = 0;
unsigned int CSM_BUF[16];
unsigned char Bounce_Count=0;
unsigned char Key_Input=0;
unsigned char CSM_Key=0;
unsigned int CSM_ever_Freq_Temp = 600;
unsigned char Disp_Count=0;

		

// *************************************************************************************
// Function: CapInit()
// Purpose: Initialize the Capacitive Sense Module and Time Base Modules
// *************************************************************************************

void Cap_Init(void)
{	
		TRISB1 = 1; 				// Set AN10/CPS1 for the Input Fucntion			
 		ANSB1 = 1;					// Set AN10/CPS1 for the Analog Input
 		CPSCON0 = 0b10001100;		// Cap sense On, High Range, T0 clock from Fosc/4
 		CPSCON1 = 0b00000001; 		// Select CPS1 channel
        
	// ********************************************************************************
	// Inititialize for Timer2 time base **********************************************
	// ********************************************************************************

		T2CON = 0b00001110;					// Postcaler 1:2, T2ON, Prescaler 1:16 
		PR2 = 249;							// Tcy 8MHz/250/2/16 = 1mS
		TMR2IF = 0;
		TMR2IE = 1;

		T1CON  = 0b11000101;				// Timer1 enable, Capacitive Sensing Oscillator, 1:1 prescale, 
		T1GCON = 0b00000000;				// Timer1 is Counter, 
		TMR1GIF = 0;						// clear gate intpt flag
		TMR1GIE = 0;	 					// Disable gate intpt
 		TMR1H	= 0;						// reset Timer1
 		TMR1L	= 0;						//   "     "
		PEIE    = 1;						// enable peripheral intpts
		GIE 	= 1;
}

void Init_Timer4(void)
{
		T4CON = 0b01001111;					// Postcaler 1:64, T2ON, Prescaler 1:10 
		PR4 = 62;							// Tcy 8MHz/62/10/64 = 5mS
		TMR4IF = 0;
		TMR4IE = 1;
}
//********************************************************************
// ISR() *************************************************************
// Interrupt Service Routine 
// Timer2 C 1mS _@AŪ Timer1 ̪ CSM Wv
// Timer4 C 5mS _@Aw (S5 & S6)ŪμuBz
//********************************************************************
//********************************************************************

void interrupt isr(void) 
{

	if (TMR2IE && TMR2IF)					// Clear T2IF every time
	{
		TMR2IF=0;
 		TMR1ON	= 0;						//  Timer1  CSM pƥ\

		CSM.Timer_Byte[0]= TMR1L;			// ^ CSM Wv
		CSM.Timer_Byte[1]= TMR1H;
		CSM_BUF[W_Index++] = CSM.Full_Timer;	// CSM WvȰe Ring Buffer 
		if (W_Index == 16) W_Index =0;		// Ring Buffer 쳻ݦmF?

 		TMR1H	= 0;						// reset Timer1
 		TMR1L	= 0;						//   "     "
 		TMR1ON	= 1;						// restart Timer1
 
		CSM_Flag = 1;
	}

	if (TMR4IE && TMR4IF)
	{
		TMR4IF=0;

		if (Disp_Count) Disp_Count--;

		if (Bounce_Count==0)				// uBz?
		{
			if (!SW5)						//  S5 O_U?
			{
				Bounce_Count=10; 			// S5 UA]wu 10
				Key_Input= 0x01;
			}  
 			if (!SW6)						//  S6 O_U?
			{
				Bounce_Count=10; 
				Key_Input= 0x02;
			}  
			
	
		}  
		else
		{
			if ( SW5 && SW6)	Bounce_Count --;  	// S5 & S6 䳣}F?
			else Bounce_Count = 10;					// SA٦QA]uBz 10 
 		}
	    if (CSM_ever_Freq_Temp <= 350) CSM_Key = 0x01;
			else CSM_Key = 0;
	}

}
